<div class="page-layout carded fullwidth" fusePerfectScrollbar>

  <div class="center">

    <mat-card>
      <mat-card-content>
        <tnm-customer-personal></tnm-customer-personal>

        <div class="panel">

            <div class="panel-title" [ngClass]="primaryColorBrand" >
                <span><mat-icon class="white-fg">assignment_ind</mat-icon></span>
                <span class="white-fg">&nbsp;Atualizar Status</span>
            </div>
            <div class="panel-content">
              <mat-form-field fxFlex="90">
                  <mat-select placeholder="Status" name="statusSelected" [(ngModel)]="statusSelected" > 
                      <mat-option value="ACTIVE">Ativo</mat-option>
                      <mat-option value="BLOCKED">Bloqueado</mat-option>
                      <mat-option value="NOT_CONFIRMED">Não confirmado</mat-option>
                      <mat-option value="CANCELED">Cancelado</mat-option>
                  </mat-select>
              </mat-form-field>
              <div fxFlex="10" style="padding-top: 10px">
                  <div fxLayoutAlign="end end" fxLayoutGap="10px">
                     <button type="button" color="primary" mat-raised-button  (click)="updateUserStatus()">Atualizar</button>
                </div>
            </div>
            </div>
          </div>
        <tnm-customer-documents></tnm-customer-documents>
        
        <div class="panel">
            <div class="panel-title" [ngClass]="primaryColorBrand" >
              <span><mat-icon class="white-fg">assignment_ind</mat-icon></span>
              <span class="white-fg">&nbsp;Atualizar Login</span>
            </div>
            <div class="panel-content">
              <form [formGroup]="loginForm" novalidate>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      <mat-form-field fxFlex="100">
                        <input type="email" matInput placeholder="Login"  formControlName="login" required>
                        <mat-error *ngIf="loginForm.get('login').hasError('required')">
                          Por favor, informe o e-mail
                        </mat-error>
                        <mat-error *ngIf="!loginForm.get('login').hasError('required') && loginForm.get('login').hasError('login')">
                          Por favor, informe um e-mail válido
                        </mat-error>
                      </mat-form-field>
                  </div>
                
                <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                  <mat-form-field fxFlex="50">
                    <input matInput placeholder="Senha" formControlName="password"  minlength="8" >
                    <mat-error *ngIf="loginForm.get('password').hasError('required')">
                      Por favor, informe a senha
                    </mat-error>
                    <mat-error *ngIf="loginForm.get('password').hasError('minlength')">
                        A senha deve ter no mínimo 8 caracteres
                    </mat-error>
                    
                  </mat-form-field>
                
                  <mat-form-field fxFlex="50">
                      <input matInput placeholder="Confirmação de senha" formControlName="confirmPassword" >
                      <mat-error *ngIf="loginForm.get('confirmPassword').hasError('passwordsNotMatch')">
                          As senhas devem ser iguais
                      </mat-error>
                    </mat-form-field>
                </div>
              </form>
            </div>   
          </div>
        
        <div class="panel" *ngIf="vehicles && vehicles.length == 1">
          <div class="panel-title" [ngClass]="primaryColorBrand">
              <mat-icon class="white-fg">directions_car</mat-icon>
              <span class="white-fg">&nbsp;Veículo</span>
          </div>

          <div class="panel-content">
                  <form [formGroup]="vehicleForm">
                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    
                      <mat-form-field fxFlex="50">
                        <input matInput placeholder="Marca" formControlName="manufacture" required style="color: black">
                      </mat-form-field>
                  
                      <mat-form-field fxFlex="50">
                        <input matInput placeholder="Modelo" formControlName="model" required style="color: black">
                      </mat-form-field>
                    </div>
  
                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      
                      <mat-form-field fxFlex="33">
                        <input matInput placeholder="Ano de fabricação" formControlName="registrationYear" required style="color: black">
                      </mat-form-field>
                    
                      <mat-form-field fxFlex="34">
                        <input matInput placeholder="Ano do modelo" formControlName="modelYear" required style="color: black">
                      </mat-form-field>
                    
                      <mat-form-field fxFlex="33">
                        <input matInput placeholder="Cor" formControlName="color" required style="color: black">
                      </mat-form-field>          
                    </div>
  
                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                      
                      <mat-form-field fxFlex="50">
                        <input matInput placeholder="Placa" formControlName="licensePlate" required style="color: black" >
                      </mat-form-field>
                    
                      <mat-form-field fxFlex="50">
                        <input matInput placeholder="Chassi" formControlName="chassi" required style="color: black" >
                      </mat-form-field>
                    </div>
  
                  </form>
          </div>
          
        </div>

        <div class="panel" *ngIf="vehicles && vehicles.length > 1">
          <div class="panel-title" [ngClass]="primaryColorBrand">
              <mat-icon class="white-fg">directions_car</mat-icon>
              <span class="white-fg">&nbsp;Veículo</span>
          </div>

          <div class="panel-content">

              <mat-table #table [dataSource]="vehicleDataSource">

                  <ng-container matColumnDef="manufacture">
                    <mat-header-cell *matHeaderCellDef> Marca </mat-header-cell>
                    <mat-cell *matCellDef="let element">{{element.manufacture}} </mat-cell>
                  </ng-container>
                 
                  <ng-container matColumnDef="model">
                    <mat-header-cell *matHeaderCellDef> Modelo </mat-header-cell>
                    <mat-cell *matCellDef="let element"> {{ element.model}}  </mat-cell>
                  </ng-container>
                 
                  <ng-container matColumnDef="registrationYear">
                    <mat-header-cell *matHeaderCellDef> Ano de fabricação </mat-header-cell>
                    <mat-cell *matCellDef="let element"> {{element.registrationYear}}</mat-cell>
                  </ng-container>
                  
                  <ng-container matColumnDef="modelYear">
                    <mat-header-cell *matHeaderCellDef> Ano do modelo </mat-header-cell>
                    <mat-cell *matCellDef="let element"> {{element.modelYear}}</mat-cell>
                  </ng-container>
                  
                  <ng-container matColumnDef="color">
                      <mat-header-cell *matHeaderCellDef> Cor </mat-header-cell>
                      <mat-cell *matCellDef="let element"> {{element.color}}</mat-cell>
                  </ng-container>

                  <ng-container matColumnDef="licensePlate">
                    <mat-header-cell *matHeaderCellDef> Placa </mat-header-cell>
                    <mat-cell *matCellDef="let element"> {{element.licensePlate}}</mat-cell>
                  </ng-container>

                  <ng-container matColumnDef="chassi">
                    <mat-header-cell *matHeaderCellDef> Chassi </mat-header-cell>
                    <mat-cell *matCellDef="let element"> {{element.chassi}}</mat-cell>
                  </ng-container>

                  <mat-header-row *matHeaderRowDef="vehicleDisplayedColumns"></mat-header-row>
                  <mat-row *matRowDef="let row; columns: vehicleDisplayedColumns;"
                          matRipple 
                          class="element-row">
                  </mat-row>
                </mat-table>
                  
          </div>
        </div>
        
        <mat-tab-group>
            <mat-tab>
                <ng-template mat-tab-label>
                  <mat-icon>description</mat-icon>
                  <span>&nbsp;Contratos</span>
                </ng-template>

                <div class="panel-content">
                  <mat-table #table [dataSource]="plansDataSource">

                      <ng-container matColumnDef="offerName">
                        <mat-header-cell *matHeaderCellDef> Plano </mat-header-cell>
                        <mat-cell *matCellDef="let element">{{element.relationships?.offer?.name}} </mat-cell>
                      </ng-container>

                      <ng-container matColumnDef="licensePlate">
                        <mat-header-cell *matHeaderCellDef> Placa </mat-header-cell>
                        <mat-cell *matCellDef="let element"> {{element.relationships.vehicle ? element.relationships.vehicle.licensePlate : '-'}}</mat-cell>
                      </ng-container>
                  
                      <ng-container matColumnDef="recurrence">
                        <mat-header-cell *matHeaderCellDef> Status do Pagamento </mat-header-cell>
                        <mat-cell *matCellDef="let element"> {{ element.agreement == "FREE" ? 'Contrato sem Pagamento' : (element.debt == 'DUE' ? 'Em Dia' : element.debt == 'OVERDUE' ? 'Em Atraso' : '-')  }}  </mat-cell>
                      </ng-container>
                  
                      <ng-container matColumnDef="status">
                        <mat-header-cell *matHeaderCellDef> Status </mat-header-cell>
                        <mat-cell *matCellDef="let element"> {{planStatusEnumToString(element.status)}}</mat-cell>
                      </ng-container>

                      <mat-header-row *matHeaderRowDef="plansDisplayedColumns"></mat-header-row>
                      <mat-row *matRowDef="let row; columns: plansDisplayedColumns;"
                              matRipple 
                              [routerLink]="['/contracts/details/', row.id]"
                              class="element-row"
                              (click)="showContract()"
                              [customerDetailRow]="row" [customerDetailRowTpl]="tpl"
                              (toggleChange)="onToggleChange($event)">
                      </mat-row>
                    </mat-table>
                </div>
                
                <ng-template #tpl let-element>
                    <div class="mat-row-detail" [@detailExpand] style="overflow: hidden">
                        <mat-table #table [dataSource]="planChargesDataSource">
                            
                          <ng-container matColumnDef="type" class="header-color">
                              <mat-header-cell *matHeaderCellDef> Tipo </mat-header-cell>
                              <mat-cell *matCellDef="let charge"> {{ChargeTypeEnumToString(charge.type)}} </mat-cell>
                            </ng-container>
                            
                            <ng-container matColumnDef="amount" class="header-color">
                                <mat-header-cell *matHeaderCellDef header-color> Valor </mat-header-cell>
                                <mat-cell *matCellDef="let charge"> {{charge.amount | currency: 'BRL'}} </mat-cell>
                            </ng-container>
                            <ng-container matColumnDef="status" class="header-color">
                                <mat-header-cell *matHeaderCellDef> Status </mat-header-cell>
                                <mat-cell *matCellDef="let charge"> {{PaymentCreditCardEnumToString(charge.status)}} </mat-cell>
                            </ng-container>     
                            <ng-container matColumnDef="scheduledDateTime" class="header-color">
                              <mat-header-cell *matHeaderCellDef> Data </mat-header-cell>
                              <mat-cell *matCellDef="let charge"> {{charge.scheduledDateTime | date: 'short'}} </mat-cell>
                            </ng-container>    
                            <ng-container matColumnDef="tries" class="header-color">
                              <mat-header-cell *matHeaderCellDef> Tentativas </mat-header-cell>
                              <mat-cell *matCellDef="let charge"> {{charge.tries}} </mat-cell>
                            </ng-container> 
                            <ng-container matColumnDef="paymentType" class="header-color">
                              <mat-header-cell *matHeaderCellDef> Forma de Pagamento </mat-header-cell>
                              <mat-cell *matCellDef="let charge"> {{paymentTypeEnumToString(charge.payment.type)}} </mat-cell>
                            </ng-container>    
                            <ng-container matColumnDef="creditCardBrand" class="header-color">
                                <mat-header-cell *matHeaderCellDef> Bandeira </mat-header-cell>
                                <mat-cell *matCellDef="let charge"> {{charge.payment.creditCardBrand}} </mat-cell>
                            </ng-container> 
                            <ng-container matColumnDef="creditCardNumber" class="header-color">
                                <mat-header-cell *matHeaderCellDef> Número </mat-header-cell>
                                <mat-cell *matCellDef="let charge"> {{charge.payment.creditCardNumber}} </mat-cell>
                            </ng-container> 

                            <ng-container matColumnDef="chevron-down" class="header-color">
                                <mat-header-cell *matHeaderCellDef> &nbsp; </mat-header-cell>
                                <mat-cell *matCellDef="let charge" style="text-align:left">
                                  
                                  <button type="button" mat-icon-button color="accent"  matTooltip="Logs da Cobranças">
                                      Logs da Cobranças
                                    </button>
                                </mat-cell>
                            </ng-container>
                          
                            <mat-header-row *matHeaderRowDef="planChargesDisplayedColumns" class="header-color"></mat-header-row>
                            <mat-row *matRowDef="let row; columns: planChargesDisplayedColumns;"
                              matRipple 
                              class="element-row"
                              [customerDetailRow]="row" [customerDetailRowTpl]="tpl1"
                             
                              (toggleChange)="onToggleLogChange($event)"
                              >
                            </mat-row>
                        </mat-table>
                        
                    </div>
                  </ng-template>

                  <ng-template #tpl1 let-element>
                    <div class="mat-row-detail" [@detailExpand] style="overflow: hidden">
                        <mat-table #table [dataSource]="planChargeLogsDataSource">
                            <ng-container matColumnDef="date" class="header-color">
                                <mat-header-cell *matHeaderCellDef> Data </mat-header-cell>
                                <mat-cell *matCellDef="let log"> {{log.dateTime | date: 'short'}} </mat-cell>
                              </ng-container>   

                            <ng-container matColumnDef="status" class="header-color">
                                <mat-header-cell *matHeaderCellDef> Status </mat-header-cell>
                                <mat-cell *matCellDef="let log"> {{log.text}} </mat-cell>
                            </ng-container>     
                            

                            <mat-header-row *matHeaderRowDef="planChargeLogsDisplayedColumns" class="header-color"></mat-header-row>
                            <mat-row *matRowDef="let row; columns: planChargeLogsDisplayedColumns;"></mat-row>
                        </mat-table>
                       
                    </div>
                  </ng-template>
              </mat-tab>

              <mat-tab>
                  <ng-template mat-tab-label>
                    <mat-icon>attach_money</mat-icon>
                    <span>&nbsp;Formas de Pagamento</span>
                  </ng-template>
                  <div class="panel-content">
                    <div *ngIf="!showPaymentForm">
                        <div fxLayout="row" fxLayoutAlign="end end">

                            <button mat-menu-item (click)="addNewPayment('CREDIT_CARD')">
                                <mat-icon>credit_card</mat-icon>
                                <span>Adicionar Cartão de Crédito</span>
                            </button>
            
                            <button mat-menu-item (click)="addNewPayment('DEBIT_CARD')">
                                <mat-icon>credit_card</mat-icon>
                                <span>Adicionar Cartão de Débito</span>
                            </button>
                       
                        </div>
            
                        <mat-table #table [dataSource]="paymentDataSource">
                            <ng-container matColumnDef="type">
                              <mat-header-cell *matHeaderCellDef> Tipo </mat-header-cell>
                              <mat-cell *matCellDef="let element"> {{element.paymentType.value}} </mat-cell>
                            </ng-container>
                            <ng-container matColumnDef="creditCardBrand">
                                <mat-header-cell *matHeaderCellDef> Bandeira </mat-header-cell>
                                <mat-cell *matCellDef="let element"> {{element.creditCardBrand ? element.creditCardBrand : element.debitCardBrand}} </mat-cell>
                            </ng-container>
                            <ng-container matColumnDef="creditCardNumber">
                                <mat-header-cell *matHeaderCellDef> Número </mat-header-cell>
                                <mat-cell *matCellDef="let element"> {{element.creditCardNumber ? element.creditCardNumber : (element.debitCardNumber | paymentCardNumber)}} </mat-cell>
                            </ng-container>     
                          
            
                            <mat-header-row *matHeaderRowDef="paymentDisplayedColumns"></mat-header-row>
                            <mat-row *matRowDef="let row; columns: paymentDisplayedColumns;"></mat-row>
                        </mat-table>
                      </div> 
                  </div>
                </mat-tab>

            <mat-tab>
              <ng-template mat-tab-label>
                <mat-icon>place</mat-icon>
                <span>&nbsp;Endereço</span>
              </ng-template>
              <div class="panel-content">
                <form [formGroup]="addressForm" novalidate>
                  
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    
                    <mat-form-field fxFlex="60">
                      <input matInput placeholder="Rua/Avenida/Alameda" formControlName="street">
                      <mat-error *ngIf="addressForm.get('street').hasError('required')">
                        Por favor, informe a Rua/Avenida/Alameda
                      </mat-error>
                    </mat-form-field>  
                
                    <mat-form-field fxFlex="20">
                      <input matInput placeholder="Número" formControlName="number">
                      <mat-error *ngIf="addressForm.get('number').hasError('required')">
                        Por favor, informe o número
                      </mat-error>
                    </mat-form-field>
                
                    <mat-form-field fxFlex="20">
                      <input matInput placeholder="Complemento" formControlName="complement">
                    </mat-form-field>
                  </div>
            
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    
                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Bairro" formControlName="district">
                      <mat-error *ngIf="addressForm.get('district').hasError('required')">
                        Por favor, informe o Bairro
                      </mat-error>
                    </mat-form-field>
                    
                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="Cidade" formControlName="city">
                      <mat-error *ngIf="addressForm.get('city').hasError('required')">
                        Por favor, informe a Cidade
                      </mat-error>
                    </mat-form-field>
                    
                    <mat-form-field fxFlex="33">
                      <mat-select placeholder="Estado" formControlName="state" required>
                          <mat-option *ngFor="let state of stateAddressList" [value]="state.key">
                            {{ state.value }}
                          </mat-option>
                        </mat-select>
                      <mat-error *ngIf="addressForm.get('state').hasError('required')">
                        Por favor, informe o Estado
                      </mat-error>
                    </mat-form-field>
                  </div>
            
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="CEP" formControlName="postalCode" [textMask]="{mask: postalCodeMask}">
                      <mat-error *ngIf="addressForm.get('postalCode').hasError('required')">
                        Por favor, informe o CEP
                      </mat-error>
                      <mat-error *ngIf="addressForm.get('postalCode').hasError('minlength')">
                        Por favor, CEP deve conter 8 caracteres
                      </mat-error>                
                    </mat-form-field>
                    
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Referência" formControlName="reference">
                    </mat-form-field>  
                  </div>

                </form>
              </div>
            </mat-tab>

            <mat-tab>
              <ng-template mat-tab-label>
                <mat-icon>import_contacts</mat-icon>
                <span>&nbsp;Contatos</span>
              </ng-template>
              <div class="panel-content">
                <div *ngIf="!showContactForm">
                  <div fxLayout="row" fxLayoutAlign="end end">
                    <button type="button" mat-icon-button color="accent" (click)="addNewContact()" matTooltip="Novo Contato">
                      <mat-icon>add_box</mat-icon>
                    </button>
                    <!-- <button mat-fab class="mat-accent-bg" id="add-contact-button" (click)="addNewContact()" aria-label="add contact"
                        *fuseIfOnDom [@animate]="{value:'*', params:{delay:'300ms',scale:'.2'}}">
                        <mat-icon>person_add</mat-icon>
                    </button> -->
                  </div>
                  
                  <mat-table #table [dataSource]="contactDataSource">
                     <ng-container matColumnDef="type" >
                          <mat-header-cell *matHeaderCellDef> Tipo  </mat-header-cell>
                          <mat-cell *matCellDef="let element"> 
                            <mat-icon [hidden]= "element.type === 'EMAIL' ? false : true">email</mat-icon> 
                            <mat-icon [hidden]= "element.type === 'MOBILE' ? false : true">phone</mat-icon> 
                          </mat-cell>
                      </ng-container>
                      <ng-container matColumnDef="name">
                        <mat-header-cell *matHeaderCellDef> Nome </mat-header-cell>
                        <mat-cell *matCellDef="let element"> {{element.name}} </mat-cell>
                      </ng-container>
                      <ng-container matColumnDef="value">
                          <mat-header-cell *matHeaderCellDef> Valor </mat-header-cell>
                          <mat-cell *matCellDef="let element"> 
                            {{element.value}} 
                          </mat-cell>
                      </ng-container>
                      <ng-container matColumnDef="edit">
                        <mat-header-cell *matHeaderCellDef> Editar </mat-header-cell>
                        <mat-cell *matCellDef="let row; let element">
                          <mat-icon (click)="editContact(row)">mode_edit</mat-icon>
                        </mat-cell>
                      </ng-container>
                      <ng-container matColumnDef="delete">
                        <mat-header-cell *matHeaderCellDef> Excluir </mat-header-cell>
                        <mat-cell *matCellDef="let row; let element">
                            <mat-icon (click)="deleteContact(row)">delete</mat-icon>
                        </mat-cell>
                      </ng-container>

                      <mat-header-row *matHeaderRowDef="contactDisplayedColumns"></mat-header-row>
                      <mat-row *matRowDef="let row; columns: contactDisplayedColumns;"></mat-row>
                  </mat-table>
                </div>
                <form *ngIf="showContactForm" [formGroup]="contactsForm" (ngSubmit)="confirmContactForm(contactsForm.value)" novalidate>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="20">
                      <mat-select placeholder="Tipo" formControlName="type">
                        <mat-option *ngFor="let type of contactTypeList" [value]="type.key">
                          {{ type.value }}
                        </mat-option>
                      </mat-select>
                      <mat-error *ngIf="contactsForm.get('type').hasError('required')">
                        Por favor, selecione a tipo
                      </mat-error>
                    </mat-form-field>                        
                    
                    <mat-form-field fxFlex="40">
                      <input matInput placeholder="Nome" required formControlName="name">
                      <mat-error *ngIf="contactsForm.get('name').hasError('required')">
                        Por favor, informe o nome do contato
                      </mat-error>
                    </mat-form-field>
                    
                    
                    <mat-form-field fxFlex="40" [hidden]= "typeMobile">
                      <input matInput placeholder="contato@emial.com"  [required]= "!typeMobile" formControlName="email" >
                      <mat-error *ngIf="contactsForm.get('email').hasError('required')">
                        Por favor, informe o valor
                      </mat-error>
                    </mat-form-field>

                    <mat-form-field fxFlex="40" [hidden]= "!typeMobile" >
                        <input matInput placeholder="xx xxxx-xxxxx"  [required]= "typeMobile" formControlName="mobileNumber" [textMask]="{mask:typeMask}">
                        <mat-error *ngIf="contactsForm.get('mobileNumber').hasError('required')">
                          Por favor, informe o valor
                        </mat-error>
                      </mat-form-field>
                  </div>
                  
                  <div fxLayout="row" fxLayoutAlign="end end" fxLayoutGap="10px">
                    <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="0px">
                      <button type="submit" color="accent" mat-icon-button matTooltip="Adicionar" [disabled]="contactsForm.invalid">
                        <mat-icon>done</mat-icon>
                      </button>
                      <button type="button" color="warn" mat-icon-button matTooltip="Cancelar" (click)="cancelContactForm()">
                        <mat-icon>cancel</mat-icon>
                      </button>                  
                    </div>
                  </div>
                </form>
              </div>
            </mat-tab>
            
            

          </mat-tab-group>

      </mat-card-content>
      
      <mat-card-actions>
        <div fxLayout="row" fxLayoutAlign="end end" fxLayoutGap="10px">
            <button type="button" mat-raised-button (click)="cancel()">Cancelar</button>
            <button type="button" color="primary" mat-raised-button [disabled]="isCustomerInvalid()" (click)="updateCustomer()">Salvar</button>
        </div>
      </mat-card-actions>
    </mat-card>  

  </div>
</div>




